import { combineReducers } from 'redux'
import components from './components'
import componentDetail from '../components/ComponentDetail/reducers'
import files from './files'
import modal from '../components/Modal/reducers'

// This is an awesome solution to overwriting
// the entire app state, due to Dan Abramov
// (https://github.com/reactjs/redux/pull/658#issuecomment-136485851)
const makeHydratable = (reducer, hydrateActionType) => {
  return function (state, action) {
    switch (action.type) {
      case hydrateActionType:
        return reducer(action.state, action)
      default:
        return reducer(state, action)
    }
  }
}

export default makeHydratable(combineReducers({
  components,
  componentDetail,
  files,
  modal,
}), 'HYDRATE')
