# Contributing

**Thank you for your interest in contributing to `lab.js`! You are more than welcome to join** — whether you have new ideas, suggestions, or would just like to muck in, please be warmly invited to do so: This is an open project! We'd be glad to hear from you, to discuss ideas and approaches, and to get you going. Thank you for taking the time!

Together, **we're building a tool to help scientists understand behavior and cognition in its many forms, and to conduct their research efficiently and transparently**.

----

### Working together

We expect all members of our community to conform to our [**code of conduct**](code-of-conduct.md), and to be excellent to one another. We strive to meet the [Apache Foundation's guidelines](https://www.apache.org/foundation/policies/conduct) in our work together.

### Reaching out

We are happy to answer your questions! The best way to get hold of us is to [join our **Slack channel**](https://slackin-nmbrcrnchrs.herokuapp.com/), where you'll often find somebody around. We'd be thrilled to have your company!

----

## How to contribute

### Reporting bugs or making suggestions

**Notice something amiss, or some room for improvement?** You're already helping by letting us know — we'd love to hear from you, and try to make things work for everyone. We track bugs and tasks using [issues](https://github.com/felixhenninger/lab.js/issues?q=is%3Aopen). Here are some steps you can take to help us fix things and help you quickly:

#### Before submitting an issue
* **Please take a quick [look whether the problem or idea has been reported already](https://github.com/felixhenninger/lab.js/issues?q=is%3Aopen)**. You can try the search function with some related terms for a cursory check. If you find a previous report, please add a comment there instead of opening a new issue. If you're unsure, you're welcome to ask!

#### Submitting a (great) bug report
* **Pick a descriptive title** that clearly identifies the issue.
* **Describe the steps that led to the problem** so that we can go through the same sequence. Does the problem reoccur when you go through the same steps once more? It is a huge help if you can provide us all the information needed to recreate the problem.
* **Briefly describe what you had expected** and how that differed from what happened, and possibly, why.

#### Making a suggestion
* Summarize your idea with a **clear title**.
* **Describe your suggestion in as much detail as possible**. How would it change the usage of the software?
* **Explain how the suggestion would be useful** to most users.

### Contribute to the code

#### Building the project

There's an [**overview of the code and intro to the build process**](https://labjs.readthedocs.io/en/latest/meta/contribute.html) in the documentation if you're interested, but as always, we'd be happy to help you get started.

#### Finding a place to start

**If you're searching for a place to contribute, please do let us know**: There's always things to do, and we'd be glad to help you find something that fits your interests and resources. If you're writing a tool that might interoperate with this one, we're more than happy to link things up; if you're looking to extend or build on this project, we'd be thrilled to provide a stepping stone for you!

You might also find a task that interests and suits you, or an inspiration, in our
* [Good **first bugs**](https://github.com/felixhenninger/lab.js/issues?q=is%3Aopen+is%3Aissue+label%3A"Good+first+bug") to help you get started
* [Upcoming **milestones**](https://github.com/felixhenninger/lab.js/milestones)
