<div align="center">
  <img src="docs/media/logo/yellow/dot_200.png">
  <h1>lab.js</h1>
</div>

<p align="center">
  <small>
    <a href="https://labjs.readthedocs.io/en/latest/learn/builder">Get started</a> ·
    <a href="https://labjs.felixhenninger.com/">Open the builder</a> ·
    <a href="https://labjs.readthedocs.io/en/latest/">Learn more</a> ·
    <a href="https://labjs.readthedocs.io/en/latest/meta/contribute.html">Contribute</a>
  </small>
</p>

**`lab.js` is a tool for constructing browser-based studies** built for (but
not limited to) the social and cognitive sciences. Studies can be assembled
using a graphical builder, or through code. In either case, `lab.js` takes care
of study presentation, response collection and data storage, while providing
the greatest possible flexibility with regard to study design.

[![Slack Status](https://img.shields.io/badge/slack-online-brightgreen.svg)](https://slackin-nmbrcrnchrs.herokuapp.com/)
[![Build Status](https://travis-ci.org/FelixHenninger/lab.js.svg?branch=master)](https://travis-ci.org/FelixHenninger/lab.js)
[![Documentation Status](https://readthedocs.org/projects/labjs/badge/?version=latest)](http://labjs.readthedocs.io/en/latest/?badge=latest)
[![DOI](https://zenodo.org/badge/47625723.svg)](https://zenodo.org/badge/latestdoi/47625723)

<div align="center">
  <img src="docs/media/promo/builder_teaser.png">
</div>

----

### Get started

The [**graphical builder interface**](https://labjs.felixhenninger.com) is the
easiest way to create studies, and the best place to start. The tutorial
will walk you through [building your first study, step by
step](https://labjs.readthedocs.io/en/latest/learn/builder/).

If you prefer working directly with code, you can build studies using the
[**JavaScript library**](https://labjs.readthedocs.io/en/latest/reference/).
Everything you need is bundled in the *starter kit*, which is [provided with
every release](https://github.com/FelixHenninger/lab.js/releases/latest).
There is also a tutorial to [help you get started](https://labjs.readthedocs.io/en/latest/learn/code/).

If you get stuck or things don't make sense, please don't hesitate to reach out!

### Find help

The easiest and quickest way to find help is to [join our **Slack
channel**](https://slackin-nmbrcrnchrs.herokuapp.com/), where there's someone
around to discuss things and help out most of the time. You're welcome to just
join and say hello!

### Keep up-to-date

If you'd like to keep in the loop regarding the development, please [subscribe
to our **newsletter**](http://eepurl.com/co0K9r) to receive very occasional
updates and release notifications.

### Help improve `lab.js`!

**We would love to have you as part of this project!** We warmly welcome ideas
and suggestions, bug reports and code contributions — please also let us know if
you'd like to join in but are unsure how, we'd be glad to help you find
something that suits your interests and resources. The [**contributor's
guide**](contributing.md) also provides further information.

----

### Contributors

(in alphabetical order)

#### Code / documentation

[Felix Henninger](http://felixhenninger.com) ·
[Ulf K. Mertens](http://www.psychologie.uni-heidelberg.de/ae/meth/team/mertens/) ·
[Yury Shevchenko](http://yuryshevchenko.com/)

#### Ideas, feedback and examples

[Jeffrey Fisher](https://github.com/jeffslofish) ·
[Robert Gaschler](https://www.fernuni-hagen.de/psychologie/psychologisches_institut/about_institute/departments/app_lme/staff/rgaschler/) ·
[Benjamin E. Hilbig](https://cognition.uni-landau.de/hilbig) ·
[Andrew White](https://github.com/shiroandy)

The students and teaching assistants in the graduate course *Research Methods
in Cognitive Psychology* at the University of Koblenz-Landau inspire the
continued development of this software, have provided countless valuable
insights, and sparked many of the ideas embodied in this project through
questions and discussions.

#### Sponsors and supporters

We are wholeheartedly grateful to our generous sponsors for making possible the
development of this tool:

[FernUniversität in Hagen](https://www.fernuni-hagen.de/psychologie/psychologisches_institut/about_institute/departments/app_lme/) ·
[GESS, University of Mannheim](http://gess.uni-mannheim.de/) ·
[Rational Altruists Mannheim](http://www.ram-ev.de/) ·
[University of Koblenz-Landau](https://www.cognition.uni-landau.de/)

If you would like to support development as a scientific institution, the
easiest way is to **host a workshop**. We'll gladly show you and your
colleagues how to build experiments using this software, and build your
favorite paradigm together! We are also open to **consulting** if you are
looking for a particular feature — please don't hesitate to get in touch so
that we can discuss things in more detail.

----

### Citation

We kindly request that you cite ``lab.js`` if you use it in your research. Here's how:

> Henninger, F., Mertens, U. K., Shevchenko, Y., & Hilbig, B. E. (2017). lab.js: Browser-based behavioral research (version 2017.1.0). doi: [10.5281/zenodo.495220](https://doi.org/10.5281/zenodo.495220)

(<a href="https://zenodo.org/record/495220/export/hx">BibTeX</a> record)

----

### License

The two parts of this project are licensed individually:

* The `lab.js` **core library** that is included in your studies is made
  available under the terms of the [Apache License](/library/license).
* The **builder**, the graphical interface used to build experiments,
  is provided under the terms of the [GNU Affero General Public
  License](/builder/license).

The studies you build based on the library, and those you create using the
builder, are always your own, and you are free to distribute them as you see
fit. When studies include the core library files, these files alone are governed
by the aforementioned license.
